<template>
  <div id="product-info-page">
    <ShowProductDetails
      :product="product"
      :actualUserRole="actualUserRole"
      :showMessage="showMessage"
      @edit-product-details-event="goToEditProductDetails"
      @reserve-product-event="reserveProduct"
    />

    <v-btn
      depressed
      small
      color="green"
      class="go-to-pannel-button"
      v-show="this.product.state === 'Confirmado'"
      @click="goToAdminPanel()"
    >Volver al panel de control</v-btn>
  </div>
</template>

<script>
import ShowProductDetails from './ShowProductDetails.vue'

import API from '@/API.js'
export default {
  name: 'ProductInfoPage',
  components: {
    ShowProductDetails
  },
  props: {
    // idActualUser: String,
    // role: String
  },

  data() {
    return {
      idActualUser: this.$route.params.idActualUser,
      showMessage: null,
      idSearched: null,

      hasShow: true,
      hasEdit: false,

      actualUserRole: '',
      ifEditProduct: false,
      product: {},
      items: [],
      dateCreate: new Date().toLocaleString()
    }
  },

  async mounted() {
    if (this.idActualUser === undefined) {
      this.idActualUser = 'visitor'
    } else {
      this.actualUserRole = await API.getIdActualUser(this.idActualUser)
    }

    this.showMessage = false
    this.defineIdSearched()
    await this.putProductDetailsEnData()
  },

  methods: {
    goToEditProductDetails() {
      let idproduct = this.product.idproduct
      this.$router.push(
        '/edit-product-detail/' + this.idActualUser + '/' + idproduct
      )
    },

    defineIdSearched() {
      this.idSearched = this.$route.params.id_product
    },
    async reserveProduct() {
      if (this.product.promos == 0) {
        await this.reserveNormalProduct()
      } else {
        await this.reservePromoProduct()
      }
    },

    async reservePromoProduct() {
      let idproduct = this.product.idproduct
      let idActualUser = this.idActualUser
      let hasEnoughSold = await API.verifySoldForPromo(idproduct, idActualUser)
      if (hasEnoughSold.posible == '0') {
        this.showMessage = true
      } else {
        await API.updatePenascalesAfterPromoReservation(idproduct, idActualUser)
        await API.updateProductStateAfterReservation(idproduct)
        await API.updateReservationsTable(idproduct, idActualUser)
        this.goToUserPanelPage()
      }
    },

    async reserveNormalProduct() {
      let idproduct = this.product.idproduct
      let idActualUser = this.idActualUser
      let hasEnoughSold = await API.verifySold(idproduct, idActualUser)
      if (hasEnoughSold.posible == '0') {
        this.showMessage = true
      } else {
        await API.updatePenascalesAfterReservation(idproduct, idActualUser)
        await API.updateProductStateAfterReservation(idproduct)
        await API.updateReservationsTable(idproduct, idActualUser)
        this.goToUserPanelPage()
      }
    },

    goToUserPanelPage() {
      let idActualUser = this.idActualUser
      this.$router.push('/UserPanelControlPage/' + idActualUser)
    },

    async putProductDetailsEnData() {
      let idSearched = this.idSearched
      this.product = await API.loadProductDetails(idSearched)
    },

    goToAdminPanel() {
      this.$router.push('/DashBoard/')
    }
  }
}
</script>


<style scoped>
#product_details {
  display: flex;
  flex-direction: column;
  justify-content: space-around;
}
.go-to-pannel-button {
  margin-top: 5%;
}
</style>
